require(GetScriptDirectory() .. "/utility")

local Talents =
{
 	"special_bonus_mp_regen_2",
	"special_bonus_movement_speed_25",
	"special_bonus_armor_7",
	"special_bonus_magic_resistance_15",
	"special_bonus_unique_zeus_2",
	"special_bonus_unique_zeus_3",
	"special_bonus_cast_range_200",
	"special_bonus_unique_zeus",
}

local Abilities =
{
    "zuus_arc_lightning",
    "zuus_lightning_bolt",
    "zuus_static_field",
    "zuus_cloud",
    "zuus_thundergods_wrath",
}

--存储技能句柄，方便调用
local npcBot=GetBot()
local AbilitiesReal =
{
    npcBot:GetAbilityByName(Abilities[1]),
    npcBot:GetAbilityByName(Abilities[2]),
    npcBot:GetAbilityByName(Abilities[3]),
    npcBot:GetAbilityByName(Abilities[4]),
    npcBot:GetAbilityByName(Abilities[5])
}
--存储加点顺序
local AbilityToLevelUp=
{
    Abilities[1],
    Abilities[3],
    Abilities[2],
    Abilities[2],
    Abilities[2],
    Abilities[5],
    Abilities[2],
    Abilities[1],
    Abilities[1],
    Talents[1],
    Abilities[1],
    Abilities[5],
    Abilities[3],
    Abilities[3],
    Talents[3],
    Abilities[3],
    Abilities[5],
    Talents[5],
    Talents[7],
}

function AbilityUsageThink()

    local npcBot = GetBot()
    -- Check if we're already using an ability
    if ( npcBot:IsUsingAbility() or npcBot:IsChanneling() )
    then 
        return
    end
    
    AttackRange=npcBot:GetAttackRange()
    ManaPercentage=npcBot:GetMana()/npcBot:GetMaxMana()
    HealthPercentage=npcBot:GetHealth()/npcBot:GetMaxHealth()
    
    -- Consider using each ability
    cast1Desire, cast1Target = Consider1();
    cast2Desire, cast2Target,cast2TargetType = Consider2();
    cast5Desire = Consider5();
    cast4Desire, cast4Location = Consider4();

    if ( cast5Desire > 0 ) 
    then
        npcBot:Action_UseAbility( AbilitiesReal[5] );
        return
    end
    
    if ( cast4Desire > 0 ) 
    then
        npcBot:Action_UseAbilityOnLocation( AbilitiesReal[4], cast4Location );
        return
    end
    
    if ( cast2Desire > 0 ) 
    then
        if(cast2TargetType=="target")
        then
            npcBot:Action_UseAbilityOnEntity( AbilitiesReal[2], cast2Target );
            return
        elseif(cast2TargetType=="location")
        then
            npcBot:Action_UseAbilityOnLocation( AbilitiesReal[2], cast2Target );
            return
        end
    end
    
    if ( cast1Desire > 0 ) 
    then
        npcBot:Action_UseAbilityOnEntity(AbilitiesReal[1], cast1Target );
        return
    end

end

function CanCast1( npcTarget )
	return npcTarget:CanBeSeen() and not npcTarget:IsMagicImmune() and not npcTarget:IsInvulnerable();
end

function CanCast2( npcTarget )
	return not npcTarget:IsMagicImmune() and not npcTarget:IsInvulnerable();
end

function CanCast5( npcTarget )
	return npcTarget:IsHero() and not npcTarget:IsMagicImmune() and not npcTarget:IsInvulnerable();
end

function Consider1()

	local npcBot = GetBot()
	
	local ability=AbilitiesReal[1];
	 if not ability:IsFullyCastable() then
        return BOT_ACTION_DESIRE_NONE, 0;
    end
	
	local CastRange = ability:GetCastRange();       --获取施法距离
    local Damage = ability:GetAbilityDamage();      --获取技能伤害，注意这个函数不一定有效...有些特殊的技能无法获取
    
    local HeroHealth=10000
    local CreepHealth=10000
    local allys = npcBot:GetNearbyHeroes( 1200, false, BOT_MODE_NONE );     --获取周围友方英雄
    local enemys = npcBot:GetNearbyHeroes(CastRange+300,true,BOT_MODE_NONE)     --获取周围敌方英雄
    local WeakestEnemy,HeroHealth=utility.GetWeakestUnit(enemys)        --获取血量最低的敌方英雄
    local creeps = npcBot:GetNearbyCreeps(CastRange+300,true)       --获取周围的敌方小兵
    local WeakestCreep,CreepHealth=utility.GetWeakestUnit(creeps)       --获取血量最低的敌方小兵
	
	--teamfightUsing
    if(npcBot:GetActiveMode() == BOT_MODE_ATTACK )
    then
        if(ManaPercentage>0.4 and #enemys+#creeps>2)        --蓝量大于40%，敌方单位数>2
        then
            if(WeakestCreep~=nil and CanCast1( WeakestCreep ))      --CanCast1是一个自定义函数，用于判断技能能不能对目标使用，请参考下一部分。
            then
                return BOT_ACTION_DESIRE_HIGH,WeakestCreep;
            end
            if(WeakestEnemy~=nil and CanCast1( WeakestEnemy ))
            then
                return BOT_ACTION_DESIRE_HIGH,WeakestEnemy; 
            end
        end
    end
	
	 --Last hit
    if ( npcBot:GetActiveMode() == BOT_MODE_LANING )
    then
        if(WeakestCreep~=nil)
        then
            if(ManaPercentage>0.4 and GetUnitToUnitDistance(npcBot,WeakestCreep)>=AttackRange-ManaPercentage)       --蓝量大于40%，而且该单位远离英雄的攻击距离
            then
                if(CreepHealth<=WeakestCreep:GetActualIncomingDamage(Damage,DAMAGE_TYPE_MAGICAL))       --伤害是否足够
                then
                    return BOT_ACTION_DESIRE_LOW,WeakestCreep; 
                end
            end 
        end
    end
	
	-- If we're farming and can hit 2+ creeps and kill 1+ 
    if ( npcBot:GetActiveMode() == BOT_MODE_FARM )
    then
        if ( #creeps >= 2 )--单位是不是足够多
        then
            if (CreepHealth<=WeakestCreep:GetActualIncomingDamage(Damage,DAMAGE_TYPE_MAGICAL))--伤害是否足够
            then
                return BOT_ACTION_DESIRE_LOW, WeakestCreep;
            end
        end
    end
	
	-- If we're pushing or defending a lane and can hit 3+ creeps, go for it
    if ( npcBot:GetActiveMode() == BOT_MODE_PUSH_TOWER_TOP or
         npcBot:GetActiveMode() == BOT_MODE_PUSH_TOWER_MID or
         npcBot:GetActiveMode() == BOT_MODE_PUSH_TOWER_BOT or
         npcBot:GetActiveMode() == BOT_MODE_DEFEND_TOWER_TOP or
         npcBot:GetActiveMode() == BOT_MODE_DEFEND_TOWER_MID or
         npcBot:GetActiveMode() == BOT_MODE_DEFEND_TOWER_BOT ) 
    then
        if ( #enemys+#creeps > 2 and ManaPercentage>0.4)--蓝量大于40%，敌方单位数>2
        then
            if (WeakestEnemy~=nil)
            then
                if ( CanCast1( WeakestEnemy )and GetUnitToUnitDistance(npcBot,WeakestEnemy)< CastRange + 75*#allys )        --判断目标，判断英雄的位置是否安全
                then
                    return BOT_ACTION_DESIRE_LOW, WeakestEnemy;
                end
            end
            if (WeakestCreep~=nil)
            then
                if ( CanCast1( WeakestCreep )and GetUnitToUnitDistance(npcBot,WeakestCreep)< CastRange + 75*#allys )
                then
                    return BOT_ACTION_DESIRE_LOW, WeakestCreep;
                end
            end
        end
    end
	
	-- If we're going after someone
    if ( npcBot:GetActiveMode() == BOT_MODE_ROAM or
         npcBot:GetActiveMode() == BOT_MODE_TEAM_ROAM or
         npcBot:GetActiveMode() == BOT_MODE_DEFEND_ALLY or
         npcBot:GetActiveMode() == BOT_MODE_ATTACK ) 
    then
        local npcTarget = npcBot:GetTarget();
        
        if(ManaPercentage>0.4)
        then
            if ( npcTarget ~= nil ) 
            then
                if ( CanCast1( npcTarget )  and GetUnitToUnitDistance(npcBot,npcTarget)< CastRange + 75*#allys)     --距离是不是足够近
                then
                    return BOT_ACTION_DESIRE_MODERATE, npcTarget;
                end
            end
        end
    end
	
	return BOT_ACTION_DESIRE_NONE, 0;
end

function Consider2()

	local ability=AbilitiesReal[2];
	
	if not ability:IsFullyCastable() then
		return BOT_ACTION_DESIRE_NONE, 0 ,"nil";
	end
	
	local CastRange = ability:GetCastRange();
	local Damage = ability:GetAbilityDamage();
	
	local HeroHealth=10000
	local CreepHealth=10000
	local allys = npcBot:GetNearbyHeroes( 1200, false, BOT_MODE_NONE );
	local enemys = npcBot:GetNearbyHeroes(CastRange+300,true,BOT_MODE_NONE)
	local WeakestEnemy,HeroHealth=utility.GetWeakestUnit(enemys)
	local creeps = npcBot:GetNearbyCreeps(CastRange+300,true)
	local WeakestCreep,CreepHealth=utility.GetWeakestUnit(creeps)
	
	--------------------------------------
	-- Global high-priorty usage
	--------------------------------------
	-- Check for a channeling enemy
	for _,enemy in pairs( enemys )
	do
		if ( enemy:IsChanneling() and CanCast2( enemy )) 
		then
			return BOT_ACTION_DESIRE_HIGH, enemy,"target";
		end
	end
	
	-- Kill enemy
	if(npcBot:GetActiveMode() ~= BOT_MODE_RETREAT )
	then
		if (WeakestEnemy~=nil)
		then
			if(HeroHealth<=WeakestEnemy:GetActualIncomingDamage(Damage,DAMAGE_TYPE_MAGICAL) )
			then
				if ( CanCast2( WeakestEnemy ) )
				then
					return BOT_ACTION_DESIRE_HIGH,WeakestEnemy,"target";
				end
			end
		end
	end
	
	--protect myself
	local enemys2 = npcBot:GetNearbyHeroes( 500, true, BOT_MODE_NONE );
	if(npcBot:WasRecentlyDamagedByAnyHero(5))
	then
		for _,enemy in pairs( enemys2 )
		do
			if ( CanCast2( enemy ) )
			then
				return BOT_ACTION_DESIRE_HIGH, enemy,"target"
			end
		end
	end
	--------------------------------------
	-- Mode based usage
	--------------------------------------
	--消耗
	--if ( npcBot:GetActiveMode() == BOT_MODE_LANING ) 
	--then
		if(ManaPercentage>0.4 and ability:GetLevel()>=2 )
		then
			if (WeakestEnemy~=nil)
			then
				if ( CanCast2( WeakestEnemy ) )
				then
					return BOT_ACTION_DESIRE_LOW,WeakestEnemy,"target";
				end
			end
		end
	--end

	-- If we're pushing or defending a lane and can hit 4+ creeps, go for it
	if ( npcBot:GetActiveMode() == BOT_MODE_PUSH_TOWER_TOP or
		 npcBot:GetActiveMode() == BOT_MODE_PUSH_TOWER_MID or
		 npcBot:GetActiveMode() == BOT_MODE_PUSH_TOWER_BOT or
		 npcBot:GetActiveMode() == BOT_MODE_DEFEND_TOWER_TOP or
		 npcBot:GetActiveMode() == BOT_MODE_DEFEND_TOWER_MID or
		 npcBot:GetActiveMode() == BOT_MODE_DEFEND_TOWER_BOT ) 
	then
		if (WeakestEnemy~=nil)
		then
			if ( CanCast2( WeakestEnemy )and GetUnitToUnitDistance(npcBot,WeakestEnemy)< CastRange + 75*#allys )
			then
				return BOT_ACTION_DESIRE_LOW,WeakestEnemy,"target";
			end
		end
	end

	-- If we're going after someone
	if ( npcBot:GetActiveMode() == BOT_MODE_ROAM or
		 npcBot:GetActiveMode() == BOT_MODE_TEAM_ROAM or
		 npcBot:GetActiveMode() == BOT_MODE_DEFEND_ALLY or
		 npcBot:GetActiveMode() == BOT_MODE_ATTACK ) 
	then
		local npcTarget = npcBot:GetTarget();

		if ( npcTarget ~= nil ) 
		then
			if ( CanCast2( npcTarget ) and GetUnitToUnitDistance(npcBot,npcTarget)< CastRange + 75*#allys)
			then
				return BOT_ACTION_DESIRE_MODERATE, npcTarget,"target";
			end
		end
	end

	return BOT_ACTION_DESIRE_NONE, 0 ,"nil";
end

function Consider5()
	
	local ability=AbilitiesReal[5]
	if not ability:IsFullyCastable() 
	then
		return BOT_ACTION_DESIRE_NONE
	end

	local Damage = 125+100*ability:GetLevel()
	local WeakestEnemy=nil
	local LowestHP=10000.0
	
	for _,Enemy in pairs (GetUnitList(UNIT_LIST_ENEMY_HEROES)) 
	do
		if Enemy~=nil
		then
			if(GetUnitToUnitDistance(npcBot,Enemy)>AbilitiesReal[2]:GetCastRange() or not AbilitiesReal[2]:IsFullyCastable())
			then
				if Enemy:IsAlive() and Enemy:CanBeSeen() and CanCast5(Enemy)
				then
					if (LowestHP>Enemy:GetHealth())
					then
						WeakestEnemy=Enemy;
						LowestHP=Enemy:GetHealth();
					end
				end
			end
		end
	end
	
	if (WeakestEnemy==nil or LowestHP<1)
	then
		return BOT_ACTION_DESIRE_NONE
	end

	if LowestHP<=WeakestEnemy:GetActualIncomingDamage(Damage,DAMAGE_TYPE_MAGICAL)
	then
		--return BOT_ACTION_DESIRE_VERYHIGH
		local time_byname=WeakestEnemy:GetUnitName()
		local allys=WeakestEnemy:GetNearbyHeroes( 600, false, BOT_MODE_ATTACK );
		if(#allys==0 or allys[1]==npcBot)
		then
			return BOT_ACTION_DESIRE_VERYHIGH
		else
			if(npcBot.ult==nil)
			then
				npcBot.ult={}
			end
			if(npcBot.ult.time_byname==nil)
			then
				npcBot.ult.time_byname={DotaTime(),WeakestEnemy,WeakestEnemy:GetPlayerID()}
			end	
		end
	end
	
	if(npcBot.ult~=nil)
	then
		for _,i in pairs(npcBot.ult)
		do
			if(DotaTime()-i[1]>=3)
			then
				if(i[2]==nil or i[2]:IsNull() or i[2]:GetHealth()<=i[2]:GetActualIncomingDamage(Damage,DAMAGE_TYPE_MAGICAL) and IsHeroAlive(i[3]))
				then
					npcBot.ult=nil
					return BOT_ACTION_DESIRE_VERYHIGH
				end
			end
		end	
	end

	
	return BOT_ACTION_DESIRE_NONE
end

function Consider4()
	
	local ability=AbilitiesReal[4]
	if not ability:IsFullyCastable() 
	then
		return BOT_ACTION_DESIRE_NONE
	end
	
	local CastRange = ability:GetCastRange();
	
	local CreepHealth=10000;
	local enemys = npcBot:GetNearbyHeroes( CastRange + 300, true, BOT_MODE_NONE );
	local WeakestEnemy,CreepHealth=utility.GetWeakestUnit(enemys)
	
	local tower=nil
	
	if ( npcBot:GetActiveMode() == BOT_MODE_PUSH_TOWER_TOP or
		 npcBot:GetActiveMode() == BOT_MODE_PUSH_TOWER_MID or
		 npcBot:GetActiveMode() == BOT_MODE_PUSH_TOWER_BOT )
	then
		local tower=npcBot:GetNearbyTowers(1500,false)
	end
	
	if (npcBot:GetActiveMode() == BOT_MODE_DEFEND_TOWER_TOP or
		npcBot:GetActiveMode() == BOT_MODE_DEFEND_TOWER_MID or
		npcBot:GetActiveMode() == BOT_MODE_DEFEND_TOWER_BOT ) 
	then
		local tower=npcBot:GetNearbyTowers(1000,true)
	end
	
	if(tower~=nil and GetUnitToUnitDistance(npcBot,tower[1])<CastRange+500)
	then
		return BOT_ACTION_DESIRE_LOW,tower[1]:GetLocation()
	end
	
	if (WeakestEnemy~=nil)
	then
		return BOT_ACTION_DESIRE_LOW,WeakestEnemy:GetLocation()
	end
	
	return BOT_ACTION_DESIRE_NONE,0
end